/**
 * smlfvalbind.y
 *
 * Standard ML function declarations.
 * See _The_definition_of_standard_ML_, Milner et al., 1997,
 * ISBN 0-262-63181-4.
 */

%token CASE  "case"
%token FUN   "fun"
%token MATCH "=>"
%token OF    "of"
%token VID
%start dec

%%

dec:
    "fun" fvalbind
  ;

fvalbind:
    sfvalbind
  | fvalbind '|' sfvalbind
  ;

sfvalbind:
    VID atpats '=' exp
  ;

exp:
    VID
  | "case" exp "of" match
  ;

match:
    mrule
  | match '|' mrule
  ;

mrule:
    pat '=' exp
  ;

atpats:
    atpat
  | atpats atpat
  ;

atpat:
    VID
  ;

pat:
    VID atpat
  ;

%%
