/* ADA calls */
/* Taken from Boullier (1984) page III-40.  Updated against ADA 83 MR. */

%token ASSIGN
%token expression IDENTIFIER
%%

simple_statement
  : procedure_call_statement
  | assignment_statement
  ;

procedure_call_statement
  : procedure_name actual_parameter_part_opt ';'
  ;

procedure_name
  : IDENTIFIER
  ;

actual_parameter_part_opt
  : /* empty */
  | actual_parameter_part
  ;

actual_parameter_part
  : '(' parameter_association_list ')'
  ;

parameter_association_list
  : parameter_association_list ',' parameter_association
  | parameter_association
  ;

parameter_association
  : expression
  | variable_name
  ;

assignment_statement
  : variable_name ASSIGN expression ';'
  ;

variable_name
  : IDENTIFIER
  | indexed_component
  ;

indexed_component
  : IDENTIFIER '(' expression_list ')'
  ;

expression_list
  : expression_list ',' expression
  | expression
  ;
