/* Java arrays */
/* See <http://java.sun.com/docs/books/jls/first_edition/html/19.doc.html#44543> */

%token Name VariableDeclarators Expression AssignmentExpression
%start BlockStatement

%%

/* 19.4 Productions from 4: Types, Values, and Variables */

Type
  : Name
  | ReferenceType
  ;

ReferenceType
  : ArrayType
  ;

ArrayType
  : Type '[' ']'
  ;

/* 19.11 Productions from 14: Blocks and Statements */

BlockStatement
  : Assignment
  | LocalVariableDeclarationStatement
  ;

LocalVariableDeclarationStatement
  : LocalVariableDeclaration ';'
  ;

LocalVariableDeclaration
  : Type VariableDeclarators
  ;

/* 19.12 Productions from 15: Expressions */

ArrayAccess
  : Name '[' Expression ']'
  ;

Assignment
  : LeftHandSide AssignmentOperator AssignmentExpression
  ;

LeftHandSide
  : ArrayAccess
  ;

AssignmentOperator
  : '='
  ;
