/**
 * smlfvalbind.y
 *
 * Standard ML function declarations.
 * See _The_definition_of_standard_ML_, Milner et al., 1997,
 * ISBN 0-262-63181-4.
 */

%token CASE
%token FUN
%token MATCH
%token OF
%token VID
%start dec

%%

dec:
    FUN fvalbind
  ;

fvalbind:
    sfvalbind
  | fvalbind '|' sfvalbind
  ;

sfvalbind:
    VID atpats '=' exp
  ;

exp:
    VID
  | CASE exp OF match
  ;

match:
    mrule
  | match '|' mrule
  ;

mrule:
    pat MATCH exp
  ;

atpats:
    atpat
  | atpats atpat
  ;

atpat:
    VID
  ;

pat:
    VID atpat
  ;

%%
